package nl.amis.library.view;

import java.util.HashMap;
import java.util.List;

import java.util.Map;

import javax.faces.context.FacesContext;

import javax.servlet.http.HttpServletRequest;

import oracle.adf.model.BindingContext;
import oracle.adf.model.binding.DCBindingContainer;
import oracle.adf.model.binding.DCUtil;

import oracle.adf.view.faces.component.core.data.CoreTable;
import oracle.adf.view.faces.context.AdfFacesContext;

import oracle.binding.OperationBinding;

public class LibraryManager {

    private String author;
    private List<Map> books;
    private CoreTable libraryBooksTable;

    public LibraryManager() {
    }

    public void setAuthor(String author) {
        this.author = author;
    }

    public String getAuthor() {
        return author;
    }

    public String findBooks() {
        DCBindingContainer bindings = getCurrentBindingContainer();
        OperationBinding operationBinding = 
            bindings.getOperationBinding("getBooks");
        operationBinding.getParamsMap().put("author", this.author);
        books = (List<Map>)operationBinding.execute();
        // now make sure to refresh the table!
        AdfFacesContext.getCurrentInstance().addPartialTarget(this.libraryBooksTable);
        return null; // stay on the same page
    }

    private DCBindingContainer getCurrentBindingContainer() {
        FacesContext ctx = FacesContext.getCurrentInstance();
        HttpServletRequest request = 
            (HttpServletRequest)ctx.getExternalContext().getRequest();
        BindingContext bcx = DCUtil.getBindingContext(request);
        DCBindingContainer container = null;
        if (bcx != null) {
            container = 
                    bcx.findBindingContainerByPath(ctx.getViewRoot().getViewId());
        }
        return container;
    }


    public String addNewBook() {
        Map newBook = new HashMap();
        newBook.put("TITLE","new");
        newBook.put("AUTHOR","");
        newBook.put("ISBN","");
        newBook.put("YEAR_OF_PUBLICATION","");
        books.add(newBook);
        // now make sure to refresh the table!
        AdfFacesContext.getCurrentInstance().addPartialTarget(this.libraryBooksTable);
        return null;
    }
    
    
    public String saveBooks() {
        DCBindingContainer bindings = getCurrentBindingContainer();
        OperationBinding operationBinding = 
            bindings.getOperationBinding("saveBooks");
        operationBinding.getParamsMap().put("books", this.books);
        operationBinding.execute();
    
        return null;
    }
    
    public List<Map> getBooks() {
        return books;
    }


    public void setLibraryBooksTable(CoreTable libraryBooksTable) {
        this.libraryBooksTable = libraryBooksTable;
    }

    public CoreTable getLibraryBooksTable() {
        return libraryBooksTable;
    }
}
